/*****************************************************
 *
 *	Control program for the PitSchuLight TV-Backlight
 *	(c) Peter Schulten, Mlheim, Germany
 *	peter_(at)_pitschu.de
 *
 *	Die unvernderte Wiedergabe und Verteilung dieses gesamten Sourcecodes
 *	in beliebiger Form ist gestattet, sofern obiger Hinweis erhalten bleibt.
 *
 * 	Ich stelle diesen Sourcecode kostenlos zur Verfgung und biete daher weder
 *	Support an noch garantiere ich fr seine Funktionsfhigkeit. Auerdem
 *	bernehme ich keine Haftung fr die Folgen seiner Nutzung.

 *	Der Sourcecode darf nur zu privaten Zwecken verwendet und modifiziert werden.
 *	Darber hinaus gehende Verwendung bedarf meiner Zustimmung.
 *
 *	History
 *	09.06.2013	pitschu		Start of work
 */



#ifndef FLASHPARAMS_H_
#define FLASHPARAMS_H_

#define PARAM_FLASH_START		0x080C0000		// 256K before ROM end (last 2 sectors)
#define PARAM_FLASH_END			0x080FFFF0		// last flash byte usable for parameters
#define	FLASH_SIGNATURE_P		0x080FFFFC		// 4 bytes (should be 'P.S.')
#define FLASH_VERSION_P			0x080FFFF8		// 4 bytes version ID 0x0001 ...

typedef struct {
	uint8_t *paraP;
	short	 paraSize;
} flashParam_t;


extern int checkForParamChanges (void);
extern int initFlashParamBlock (void);
extern int readAllParamsFromFlash (void);
extern int updateAllParamsToFlash (int forceErase);

#endif /* FLASHPARAMS_H_ */
